Subject: Re: [PATCH v2 04/13] Connection Manager

From: Evgeniy Polyakov <[email-masked]>
Date: Tue, 5 Dec 2006 18:27:36 +0300

On Tue, Dec 05, 2006 at 09:14:36AM -0600, Steve Wise ([email-masked]) wrote:
> Chelsio doesn't implement TCP stack in the driver.  Just like Ammasso,
> it sends messages to the HW to setup connections.  It differs from
> Ammasso in at least 2 ways:
> 
> 1) Ammasso does the MPA negotiations in FW/HW.  Chelsio does it in the
> RDMA driver.  So there is code in the Chelsio driver to handle MPA
> startup negotiation (the exchange of 2 packets over the TCP connection
> while its still in streaming more).  BTW: This code _could_ be moved
> into the core IWCM if we find it could be used by other rnic devices
> (don't know yet).
> 
> 2) Ammasso implments a 100% deep adapter.  It does ARP, routing, IP,
> TCP, and IWARP protocols all in firmware/hw.  It had 2 mac addresses
> simulating 2 ethernet ports.  One exclusively for RDMA connections, and
> one for host stack traffic.  Chelsio implements a shallower adapter that
> only does TCP in HW.  ARP, for instance, is handled by the native stack
> and the rdma driver uses netevents to maintain arp tables in the HW for
> use by the offloaded TCP connections.

So breifly saying - there is TCP stack implementation (including ARP and
routing and other parts) in hardware/firmware/driver which is guaranteed
to not be visible to host other than in form of high-level dataflow.
Am I right here?

> Steve.
> 
> 
> 
> -
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html

-- 
	Evgeniy Polyakov